/* AuthorListController */

#import <Cocoa/Cocoa.h>

@class	BCMainController, AuthorName;
@protocol NSTableDataSource;

@interface AuthorListController : NSObject <NSTableDataSource>
{
    IBOutlet BCMainController	*mainDocument;
    IBOutlet NSTableView		*tableAuthor;
    IBOutlet NSTextField		*statusAuthors;
    IBOutlet NSSearchField		*stringAuthorSearch;	
	IBOutlet NSMenu				*searchMenu;

	NSDictionary		*allNames;			// dict of name -> NSArray of AuthorName+BibItem's
	NSMutableArray		*displayedNames;	// array of AuthorName
	
	float				fontSize;
}

- (IBAction)authorSearch:(id)sender;

- (void)notified:(id)notification;
- (void)selectionChanged;

- (int)totalAuthors;
- (int)displayedAuthors;

- (void)setAuthors:(NSDictionary*)authorDic;	// dict of name -> NSArray of AuthorName+BibItem's

- (void)refleshAuthorList;

- (AuthorName*)firlstSelection;
- (NSArray*)selectedItems;
- (void)appendItems:(NSArray*)itemList into:(NSMutableArray*)selectedItems;

- (NSArray*)selectedAuthorNames;
- (void)selectAuthorsByNames:(NSArray*)names;

- (void)refleshStatus;

- (void)forceSelectAll;

- (void)clearIncrementalSearch;

- (void)prefsChanged;

@end
