//
//  AuthorName.h
//  BibCompanion
//
//  Created by Hitoshi Nakahara on 04/11/29.
//  Copyright 2004 Hit-C Soft House. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import	"BibItem.h"

@class	StringInputStream;

@interface AuthorName : NSObject {

	NSString		*familyName, *givenName, *nameForSearch;
	
	BOOL			all, others, japanese;
}

- (id)init;
- (void)dealloc;

+ (id)authorNameForAllAuthors;
+ (id)authorNameFromStream:(StringInputStream*)inStream;
+ (id)texAuthorNameFromStream:(StringInputStream*)inStream;

+ (NSArray*)createNamesFrom:(NSString*)names;
+ (NSArray*)createTeXNamesFrom:(NSString*)names;

- (void)initForAllAuthors;
- (BOOL)readFromStream:(StringInputStream*)inStream keepTeX:(BOOL)keepTeX;

- (NSString*)stringValueWithFormat:(BC_AuthorNameOrder)format;
- (NSString*)stringValue;
- (NSString*)familyName;
- (NSString*)givenName;
- (NSString*)nameForSearch;
- (NSString*)familyNameForKey;
- (NSString*)givenNameForKey;

- (BOOL)isAll;
- (BOOL)isOthers;
- (BOOL)isJapanese;

- (BOOL)partIsFamily:(NSString*)part;
- (NSString*)initialize:(NSString*)part keepTeX:(BOOL)keepTeX;
- (NSString*)initialLetterFromStream:(StringInputStream*)inStream keepTeX:(BOOL)keepTeX;
- (NSString*)removeDiacriticalMarks:(NSString*)name;

- (NSComparisonResult)compareNames:(AuthorName*)anotherName;

@end
