//
//  ConvertFromTeX.h
//  BibCompanion
//
//  Created by Hitoshi Nakahara on 05/04/12.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@class	StringInputStream, StringOutputStream;

@interface ConvertFromTeX : NSObject {

	NSCharacterSet			*alphabetSet;
	NSCharacterSet			*cmdDelimtterSet;
	
	NSDictionary			*textStyleCommands;			// text style commands

	NSArray					*bothModeIgnoreCommands;	// ignored commands
	NSArray					*mathModeIgnoreCommands;

	NSDictionary			*bothModeCommands0;			// simple commands
	NSDictionary			*mathModeCommands0;

	NSDictionary			*bothModeCommands1;			// single parameter commands

	NSDictionary			*mathModeEscapeCommands;	// textmode in mathmode

	NSMutableDictionary		*accentDic;					// accent commands
}

- (NSString*)convert:(NSString*)inString;
- (NSString*)convertStream:(StringInputStream*)inStream mathMode:(BOOL)mathMode;

- (NSString*)openDoubleQuotes;
- (NSString*)openSingleQuote;
- (NSString*)closeDoubleQuotes;
- (NSString*)closeSingleQuote;
- (NSString*)primeLetter;
- (NSString*)minusLetter;
- (NSString*)enDash;
- (NSString*)emDash;
- (NSString*)inverseQuestion;
- (NSString*)inverseExclamation;
- (NSString*)lessThanLetter;
- (NSString*)greaterThanLetter;

- (NSString*)convertAccent:(NSString*)command withStream:(StringInputStream*)inStream;
- (NSString*)convertTeXCommand:(StringInputStream*)inStream mathMode:(BOOL)mathMode;
- (NSString*)convertSubScript:(StringInputStream*)inStream;
- (NSString*)convertSuperScript:(StringInputStream*)inStream;
- (NSString*)unknownCommand:(NSString*)command;
- (void)putVariable:(unichar)aChar toStream:(StringOutputStream*)outStream;

- (NSString*)readTeXCommandFromStream:(StringInputStream*)inStream;
- (NSString*)readParameterFromStream:(StringInputStream*)inStream;
- (NSString*)readBlockParameterFromStream:(StringInputStream*)inStream;

- (BOOL)commandIsAccent:(NSString*)command;
- (unichar)commandIsLetter:(NSString*)command;

@end
