//
//  DatabaseGroup.h
//  BibCompanion
//
//  Created by Hitoshi Nakahara on 04/11/18.
//  Copyright 2004 Hit-C Soft House. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import	"LibraryGroup.h"

@class	LocalDatabase, RemoteDatabase, RealDatabase;

@interface DbGroupProperties : LibGroupProperties {

}

+ (DbGroupProperties*)propertiesWithDatabase:(BibDatabase*)db;
+ (DbGroupProperties*)propertiesWithDictionary:(NSDictionary*)propertyDic database:(BibDatabase*)db;
+ (DbGroupProperties*)propertiesWithProperties:(DbGroupProperties*)source;

- (id)initWithDatabase:(BibDatabase*)db;
- (void)readFromDictionary:(NSDictionary*)propertyDic;
- (void)makeCopyOf:(DbGroupProperties*)source;
- (NSMutableDictionary*)makePropertyDictionary;

@end

//////////


@interface DatabaseGroup : LibraryGroup {

}

+ (DatabaseGroup*)dbGroup;
+ (DatabaseGroup*)dbGroupWithDictionary:(NSDictionary*)propertyDic;
- (id)initWithDictionary:(NSDictionary*)propertyDic;

- (void)openProperty;

- (BOOL)isDirty;

- (LocalDatabase*)findDatabaseWithFullPath:(NSString*)path;
- (BOOL)saveDocuments;
- (int)unsavedDatabases:(NSMutableString**)databaseNames;
- (NSArray*)getDbListExceptFor:(RealDatabase*)exceptItem;
- (NSArray*)getFullPathList;

- (void)loadAllDatabases;

- (void)databaseOpened:(RealDatabase*)realDB;
- (void)databaseClosed:(RealDatabase*)realDB;
- (BOOL)bibItemChanged:item;

- (void)move:(BibDatabase*)item toIndex:(int)newIndex;

@end
