/* DetailInfoController */

#import <Cocoa/Cocoa.h>

@class	BibItem, FilePathButton, URLButton, EmailButton, FilePathField, URLField, EmailField;
@class	FileViewController, BibFieldDataField, AnnotationText, RawFieldText, InputAccentButton;
@class	RealDatabase, BCMainController;

@interface DetailInfoController : NSObject
{
    IBOutlet NSButton *buttonEnableEdit;
    IBOutlet NSButton *buttonUndoEdit;
	IBOutlet NSTabView *tabViewDetail;

    IBOutlet BibFieldDataField *stringBasicInfo01;
    IBOutlet BibFieldDataField *stringBasicInfo02;
    IBOutlet BibFieldDataField *stringBasicInfo03;
    IBOutlet BibFieldDataField *stringBasicInfo04;
    IBOutlet BibFieldDataField *stringBasicInfo05;
    IBOutlet BibFieldDataField *stringBasicInfo06;
    IBOutlet BibFieldDataField *stringBasicInfo07;
    IBOutlet BibFieldDataField *stringBasicInfo08;
    IBOutlet BibFieldDataField *stringBasicInfo09;
    IBOutlet BibFieldDataField *stringBasicInfo10;
    IBOutlet BibFieldDataField *stringOptInfo01;
    IBOutlet BibFieldDataField *stringOptInfo02;
    IBOutlet BibFieldDataField *stringOptInfo03;
    IBOutlet BibFieldDataField *stringOptInfo04;
    IBOutlet BibFieldDataField *stringOptInfo05;
    IBOutlet BibFieldDataField *stringOptInfo06;
    IBOutlet BibFieldDataField *stringOptInfo07;
    IBOutlet BibFieldDataField *stringOptInfo08;
    IBOutlet BibFieldDataField *stringOptInfo09;

    IBOutlet FilePathField *stringFilePath;
    IBOutlet URLField *stringUrl;
    IBOutlet EmailField *stringEmail;
    IBOutlet FilePathButton *buttonOpenFile;
    IBOutlet URLButton *buttonOpenURL;
    IBOutlet EmailButton *buttonSendMail;
	IBOutlet NSPopUpButton *popupCopyChoice;
	IBOutlet NSButton *checkRenameFiles;
	IBOutlet NSTextField *stringCopyDestination;
	IBOutlet NSButton *buttonChoose;

    IBOutlet AnnotationText *textAnnotation;
    IBOutlet RawFieldText *textRawField;

    IBOutlet NSButton *buttonOpenSupportDrawer;
	IBOutlet NSDrawer *drawerInputSupport;
	IBOutlet NSTabView *tabInputButtons;
	
    IBOutlet InputAccentButton *buttonAcute;
    IBOutlet InputAccentButton *buttonGrave;
    IBOutlet InputAccentButton *buttonCirconflexe;
    IBOutlet InputAccentButton *buttonTilde;
    IBOutlet InputAccentButton *buttonUmlaut;
    IBOutlet InputAccentButton *buttonDblAcute;
    IBOutlet InputAccentButton *buttonDot;
    IBOutlet InputAccentButton *buttonUnderDot;
    IBOutlet InputAccentButton *buttonMacron;
    IBOutlet InputAccentButton *buttonUnderBar;
    IBOutlet InputAccentButton *buttonBreve;
    IBOutlet InputAccentButton *buttonCaron;
    IBOutlet InputAccentButton *buttonCedilla;
    IBOutlet InputAccentButton *buttonCircle;
    IBOutlet InputAccentButton *buttonAccent01;
    IBOutlet InputAccentButton *buttonAccent02;
    IBOutlet InputAccentButton *buttonAccent03;
    IBOutlet InputAccentButton *buttonAccent04;
    IBOutlet InputAccentButton *buttonAccent05;
    IBOutlet InputAccentButton *buttonAccent06;
    IBOutlet InputAccentButton *buttonAccent07;
    IBOutlet InputAccentButton *buttonAccent08;
    IBOutlet InputAccentButton *buttonAccent09;
    IBOutlet InputAccentButton *buttonAccent10;
    IBOutlet InputAccentButton *buttonAccent11;

    IBOutlet NSMatrix *radioGreeksSupport;
    IBOutlet NSMatrix *radioOthersSupport;
	
	IBOutlet NSPopUpButton *popupMacroSupport;
	IBOutlet NSButton *buttonGenerateBibKey;
	IBOutlet NSButton *buttonEditOthers;
	IBOutlet NSButton *checkOpenAuto;
	
	IBOutlet NSMenu	*menuWindow;
	IBOutlet NSMenu	*menuBibitem;
	IBOutlet NSMenu	*menuItemContext;

	IBOutlet BCMainController *mainController;
	IBOutlet FileViewController	*controllerFileView;
	
	NSArray				*bibfieldDataObjects;
	NSArray				*accentButtons;
	NSArray				*letterButtons;
	
	NSString			*lastDisplayedBibType;
	NSArray				*lastDisplayedFieldDefs;
	
	BibItem				*currentItem;
	NSString			*lastTabView;
	BOOL				executingUndo;
	
	BOOL				autoOpenPanel;
	
	RealDatabase		*databaseForMacro;
}

- (IBAction)undoEdit:(id)sender;
- (IBAction)enableEdit:(id)sender;
- (IBAction)generateBibKey:(id)sender;
- (IBAction)openAutoChanged:(id)sender;
- (IBAction)chooseAttachmentFolder:(id)sender;
- (IBAction)attachmentChoiceChanged:(id)sender;
- (IBAction)renameFileChanged:(id)sender;

- (IBAction)unlockItemEdit:(id)sender;
- (IBAction)openInputSupportPanel:(id)sender;

- (void)showDetail:(BOOL)show;
- (void)showTab:(NSString*)identifier;

- (BOOL)isEnableEdit;
- (void)setEenableEdit:(BOOL)enable;
- (void)enableSupportButtons:(BOOL)enable;

- (void)setItem:(BibItem*)item;
- (void)reload;

- (void)clearFieldData;
- (void)setUndefinedFieldNames;

- (void)fieldDataChanged;
- (void)rawDataChanged;
- (void)bibtypeChanged:(NSString*)newType;

- (void)forceEditMode;

- (void)buildMacroMenu;
- (void)setupAttachmentAction;
- (void)setAttachmentPath:(NSString*)path;

- (void)fixCurrentItem;

- (void)itemMarkChenged:(BibItem*)item;

- (void)setInputButtons;
- (void)buttonSettingChanged;

- (void)prefsChanged;

@end
