//
//  FormatElement.h
//  BibCompanion
//
//  Created by Hitoshi Nakahara on 05/01/11.
//  Copyright 2005 Hit-C Soft House. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import	"BibItem.h"

#ifndef	BC_FormStyle
typedef	enum BC_FormStyle {
	BC_FormStyle_invalid = -1,
	BC_FormStyle_normal = 0,		// [xxx] or [\xxx]
	BC_FormStyle_italic,			// [/xxx]
	BC_FormStyle_bold,				// [|xxx]
	BC_FormStyle_underline			// [_xxx]
} BC_FormStyle;
#endif

@class	StringInputStream, BibItem;

@interface FormatElement : NSObject {

	NSString			*elementString;		// field target is '<<XXX>>'
	NSMutableArray		*fieldNames;		// field name candidates
	BC_FormStyle		style;
}

- (id)initWithStream:(StringInputStream*)inStream errorStr:(NSString**)errorStr;
+ (FormatElement*)formatElementFromStream:(StringInputStream*)inStream errorStr:(NSString**)errorStr;

+ (NSArray*)elementArrayWithString:(NSString*)inString errorStr:(NSString**)errorStr;
+ (NSString*)normalizedStringOf:(NSString*)inString errorStr:(NSString**)errorStr;

- (NSString*)normalizedString;
- (NSString*)elementString;
- (NSArray*)fieldNames;

- (NSString*)fieldStringWithItem:(BibItem*)item;
- (NSString*)elementStringOfItem:(BibItem*)item withFormat:(BCListFormatType)format;
//- (NSAttributedString*)elementAttributedStringWithItem:(BibItem*)item attributes:(NSDictionary*)normalAttrib;

@end
