//
//  LibraryGroup.h
//  BibCompanion
//
//  Created by Hitoshi Nakahara on 05/02/10.
//  Copyright 2005 Hit-C Soft House. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import	"BibDatabase.h"

@interface LibGroupProperties : DatabaseProperties {

}

+ (LibGroupProperties*)propertiesWithDatabase:(BibDatabase*)db;
+ (LibGroupProperties*)propertiesWithDictionary:(NSDictionary*)propertyDic database:(BibDatabase*)db;
+ (LibGroupProperties*)propertiesWithProperties:(LibGroupProperties*)source;

- (id)initWithDatabase:(BibDatabase*)db;
- (void)readFromDictionary:(NSDictionary*)propertyDic;
- (void)makeCopyOf:(LibGroupProperties*)source;
- (NSMutableDictionary*)makePropertyDictionary;

@end

//////////


@interface LibraryGroup : BibDatabase {

}

+ (LibraryGroup*)libGroup;
+ (LibraryGroup*)libGroupWithName:(NSString*)name children:(NSArray*)children;
+ (LibraryGroup*)libGroupWithDictionary:(NSDictionary*)propertyDic;

- (id)initWithName:(NSString*)name children:(NSArray*)children;
- (id)initWithDictionary:(NSDictionary*)propertyDic;

- (void)openProperty;

- (void)_removeChildrenIdenticalTo:(NSArray*)children;

@end
