//
//  ManualLibrary.h
//  BibCompanion
//
//  Created by Hitoshi Nakahara on 05/01/18.
//  Copyright 2005 Hit-C Soft House. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import	"BibDatabase.h"

#ifndef	BC_ManualLibFileExtension

#define		BC_ManualLibFileExtension		@"manlib"

#endif


@class	RealDatabase, BibItem;

@interface ManucalLibProperties : DatabaseProperties {
}

+ (ManucalLibProperties*)propertiesWithDatabase:(BibDatabase*)db;
+ (ManucalLibProperties*)propertiesWithDictionary:(NSDictionary*)propertyDic database:(BibDatabase*)lib;
+ (ManucalLibProperties*)propertiesWithProperties:(ManucalLibProperties*)source;

- (id)initWithDatabase:(BibDatabase*)db;
- (void)readFromDictionary:(NSDictionary*)propertyDic;
- (void)makeCopyOf:(ManucalLibProperties*)source;
- (NSMutableDictionary*)makePropertyDictionary;

@end

//////////


@interface ManualLibrary : BibDatabase {

		NSDictionary	*remainingItemsDic;
}

+ (ManualLibrary*)manualLibrary;
+ (ManualLibrary*)manualLibraryWithName:(NSString*)name;
+ (ManualLibrary*)manualLibraryWithDictionary:(NSDictionary*)propertyDic;
+ (ManualLibrary*)manualLibraryWithFile:(NSString*)path;
- (id)initWithName:(NSString*)name;
- (id)initWithDictionary:(NSDictionary*)propertyDic;
- (id)initWithFile:(NSString*)path;
- (void)loadRemainingItems;

- (void)openProperty;

- (BibItem*)addCopyOfBibItem:(BibItem*)bibItem;

- (void)databaseOpened:(RealDatabase*)realDB;
- (void)databaseClosed:(RealDatabase*)realDB;

- (BOOL)saveManualLibs;
- (BOOL)removeLibDataFile;

@end
