/* PrefsController */

#import <Cocoa/Cocoa.h>
#import "BibItem.h"

@class	BibPreferences, FieldNameField, MacroList, EncodingPopUp;
@class	MacroListTableView;
@protocol NSTableDataSource;

@interface PrefsController : NSObject <NSTableDataSource>
{
    IBOutlet NSTabView *prefsTab;
    IBOutlet NSButton *buttonOK;
    IBOutlet NSButton *buttonCancel;
    IBOutlet NSButton *buttonRevert;
	
    IBOutlet EncodingPopUp *popupTextEncoding;
    IBOutlet NSPopUpButton *popupNewLineCode;
    IBOutlet NSPopUpButton *popupCopyAction;
    IBOutlet NSButton *checkConvertToYen;
    IBOutlet NSButton *checkSmartAuthorPaste;
    IBOutlet NSButton *checkSmartTitlePaste;
    IBOutlet NSPopUpButton *popupFieldFontSize;
    IBOutlet NSPopUpButton *popupListFontSize;
    IBOutlet NSButton *buttonEditNouns;
    IBOutlet NSButton *checkAutoSave;
    IBOutlet NSTextField *numSaveInterval;
    IBOutlet NSTextField *numBackups;
    IBOutlet NSTextField *bibKeyRule;
    IBOutlet NSTableView *tableListView;
    IBOutlet NSPopUpButton *popupNameFormat;

    IBOutlet NSPopUpButton *popupBibType;
    IBOutlet NSButton *buttonAddBibType;
    IBOutlet NSButton *buttonRemoveBibType;
    IBOutlet FieldNameField *basicField01;
    IBOutlet FieldNameField *basicField02;
    IBOutlet FieldNameField *basicField03;
    IBOutlet FieldNameField *basicField04;
    IBOutlet FieldNameField *basicField05;
    IBOutlet FieldNameField *basicField06;
    IBOutlet FieldNameField *basicField07;
    IBOutlet FieldNameField *basicField08;
    IBOutlet FieldNameField *basicField09;
    IBOutlet FieldNameField *basicField10;
    IBOutlet NSButton *checkBasic01;
    IBOutlet NSButton *checkBasic02;
    IBOutlet NSButton *checkBasic03;
    IBOutlet NSButton *checkBasic04;
    IBOutlet NSButton *checkBasic05;
    IBOutlet NSButton *checkBasic06;
    IBOutlet NSButton *checkBasic07;
    IBOutlet NSButton *checkBasic08;
    IBOutlet NSButton *checkBasic09;
    IBOutlet NSButton *checkBasic10;
    IBOutlet FieldNameField *optionField01;
    IBOutlet FieldNameField *optionField02;
    IBOutlet FieldNameField *optionField03;
    IBOutlet FieldNameField *optionField04;
    IBOutlet FieldNameField *optionField05;
    IBOutlet FieldNameField *optionField06;
    IBOutlet FieldNameField *optionField07;
    IBOutlet FieldNameField *optionField08;
    IBOutlet FieldNameField *optionField09;
    IBOutlet NSButton *checkOption01;
    IBOutlet NSButton *checkOption02;
    IBOutlet NSButton *checkOption03;
    IBOutlet NSButton *checkOption04;
    IBOutlet NSButton *checkOption05;
    IBOutlet NSButton *checkOption06;
    IBOutlet NSButton *checkOption07;
    IBOutlet NSButton *checkOption08;
    IBOutlet NSButton *checkOption09;
    IBOutlet NSTableView *tableListFormat;
    IBOutlet NSButton *checkAbbrevNames;
    IBOutlet NSTextField *nonAbbrevNumber;
    IBOutlet NSTextField *abbrevNumber;
    IBOutlet NSPopUpButton *popupNameFormatOnCopy;
    IBOutlet NSTextField *nameDelimiter;
    IBOutlet NSPopUpButton *popupListFormatOnCopy;
	
    IBOutlet NSButton *buttonAdd;
    IBOutlet NSButton *buttonImport;
    IBOutlet NSButton *buttonSort;
	IBOutlet MacroListTableView	*tableMacros;

    IBOutlet NSTextField *newTypePrompt;
    IBOutlet NSTextField *newTypeField;

	IBOutlet NSPanel *prefsSheet;
	IBOutlet NSPanel *newTypePanel;
	IBOutlet NSWindow *mainWindow;
	
	NSArray			*basicFields, *basicChecks;
	NSArray			*optionFields, *optionChecks;
	
	NSMutableArray		*listViews;
	NSMutableDictionary	*currentTypeDefs;
	NSMutableArray		*currentTypeOrder;
	NSMutableArray		*currentDisplayFields;
	NSMutableArray		*currentFieldRequirements;
	NSMutableArray		*currentFormatList;
	
	NSArray				*properNouns;
	NSArray				*longConjunctions;
	NSArray				*shortNormalWords;
	
	NSString			*lastEncodingSelection;
	
	BC_AuthorNameOrder	prevNameFormat;
	
	BOOL		macroIsDirty, formatIsDirty;
	BOOL		dirty;
}
- (IBAction)ok:(id)sender;
- (IBAction)cancel:(id)sender;
- (IBAction)revert:(id)sender;
- (IBAction)bibTypeChanged:(id)sender;
- (IBAction)removeBibType:(id)sender;
- (IBAction)encodingChanged:(id)sender;
- (IBAction)showHelp:(id)sender;
- (IBAction)editProperNouns:(id)sender;
- (IBAction)autoSaveChanged:(id)sender;
- (IBAction)smartTitlePasteChanged:(id)sender;
- (IBAction)abbrevAuthorChanged:(id)sender;
- (IBAction)authorFormatChanged:(id)sender;

- (IBAction)import:(id)sender;

- (IBAction)addBibType:(id)sender;
- (IBAction)newTypeOk:(id)sender;
- (IBAction)newTypeCancel:(id)sender;

- (IBAction)openPreferences:(id)sender;
- (void)setCurrentTypeDefsWith:(BibPreferences*)prefs;

- (void)getValuesFrom:(BibPreferences*)prefs;
- (void)putValuesTo:(BibPreferences*)prefs;

- (void)notified:(NSNotification*)notification;

- (NSString*)fieldsToString:(NSArray*)fields startAt:(int)startIndex;
- (NSArray*)stringToFields:(NSString*)str;

- (void)setCurrenBibDefs;
- (void)getCurrenBibDefs;

- (IBAction)editEncodingMenu:(id)sender;

- (void)setProperNouns:(NSArray*)properList longConjunctions:(NSArray*)longList
			shortNormals:(NSArray*)shortList;

- (BOOL)objectIsDetailField:(id)object;

@end
