//
//  StringInputStream.h
//  BibCompanion
//
//  Created by Hitoshi Nakahara on 04/11/25.
//  Copyright 2004 Hit-C Soft House. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface StringInputStream : NSObject {

	//NSCharacterSet			*whitespaceSet, *newlineSet;
	//NSMutableCharacterSet		*wordDelimiterSet;

	//NSCharacterSet	*gWhitespaceSet, *gNewlineSet, *gWordDelimiterSet;
	
	unichar			*buffer;
	unichar			*currentPos, *maxPos;
	BOOL			spacesToASpace, yenToBackslash;
	BOOL			lastCharWasASpace;
}

+ (void)setupCharacterSets;

- (id)init;
- (id)initWithString:(NSString*)inputString;
- (void)dealloc;

+ (StringInputStream*)stringInputStreamWithString:(NSString*)inputString;

- (BOOL)spacesToASpace;
- (void)setSpacesToASpace:(BOOL)yesOrNo;
- (BOOL)yenToBackslash;
- (void)setYenToBackslash:(BOOL)yesOrNo;

- (unichar)getChar;
- (unichar)getNonSpaceChar;
- (unichar)getNonDelimiterChar;
- (void)ungetChar;

- (NSString*)getWord;
- (NSString*)getWordNonSpace;
- (NSString*)getWordBeginsWith:(unichar)startChar;

- (void)skipToEndOfLine;
- (void)skipWord;

- (void)rewind;
- (void)setPosition:(CFIndex)pos;
- (CFIndex)position;

@end
