//
//  TeXtoText.h
//  BibCompanion
//
//  Created by Hitoshi Nakahara on 04/11/28.
//  Copyright 2004 Hit-C Soft House. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import	"ConvertFromTeX.h"

@class	StringInputStream;

@interface TeXtoText : ConvertFromTeX {

	NSCharacterSet		*superScriptSet, *subScriptSet;
	NSString			*superExpNum, *subExpNum;
	//StringInputStream	*superScriptCmd, *superScriptExp, *subScriptCmd, *subScriptExp;
	NSDictionary		*superDic, *subDic;

	NSString			*openDoubleQuotes, *openSingleQuote, *closeDoubleQuotes, *closeSingleQuote;
	NSString			*primeLetter, *minusLetter, *enDash, *emDash, *inverseQuestion, *inverseExclamation;
}

+ (id)createGlobalObject;
+ (void)releaseGlobal;

+ (TeXtoText*)globalConverter;

+ (NSString*)convertString:(NSString*)inString;

- (NSString*)convertAccent:(NSString*)command withStream:(StringInputStream*)inStream;
- (NSString*)convertSubScript:(StringInputStream*)inStream;
- (NSString*)convertSuperScript:(StringInputStream*)inStream;
- (NSString*)unknownCommand:(NSString*)command;

- (NSString*)openDoubleQuotes;
- (NSString*)openSingleQuote;
- (NSString*)closeDoubleQuotes;
- (NSString*)closeSingleQuote;
- (NSString*)primeLetter;
- (NSString*)minusLetter;
- (NSString*)enDash;
- (NSString*)emDash;
- (NSString*)inverseQuestion;
- (NSString*)inverseExclamation;

@end
