//
//  UnicodeToTeX.h
//  BibCompanion
//
//  Created by Hitoshi Nakahara on 05/02/22.
//  Copyright 2005 2005 Hit-C Soft House. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface UnicodeToTeX : NSObject {

	NSMutableDictionary	*letterDic;
	NSMutableDictionary	*symbolDic;
	NSMutableDictionary	*mathDic;
	NSMutableDictionary	*mathDic1;
	
	NSCharacterSet		*numberCharSet;
	
	NSString			*accentOnlyDot, *accentOnlyGrave, *accentOnlyMacron, *accentOnlyTilde, *accentOnlyUmlaut;
	NSString			*accentOnlyAcute, *accentOnlyCirconflexe, *accentOnlyDoubleAcute, *accentOnlyCedilla;
	NSString			*accentOnlyBreve, *accentOnlyCaron, *accentOnlyCircle, *accentOnlyUBar, *accentOnlyUDot;
	NSString			*iForAccent;
}

+ (id)createGlobalObject;
+ (void)releaseGlobal;

+ (UnicodeToTeX*)globalConverter;
+ (void)convertStringLetter:(NSMutableString**)inString;
+ (void)convertStringSymbols:(NSMutableString**)inString;
+ (void)convertStringMath:(NSMutableString**)inString;

- (void)convertStringLetter:(NSMutableString**)inString;
- (void)convertStringSymbols:(NSMutableString**)inString;
- (void)convertStringMath:(NSMutableString**)inString;

- (void)convert:(NSMutableString**)string withDictionary:(NSDictionary*)convDic;
- (void)convertWithParam:(NSMutableString**)string withDictionary:(NSDictionary*)convDic;

- (void)convertCombinedAccent:(NSMutableString**)string;
- (void)convert:(NSMutableString**)string withAccent:(NSString*)accentChar withFormat:(NSString*)format;

@end
